<template>
  <basic-container>
    <div class="main">
      <div class="top">
        <div class="testbox" style="">
          <div>
            <!-- <el-button plain size="small" type="primary" @click="addvisible = true">增加
            </el-button>
            <el-button plain size="small" type="primary" @click="editHandler">编辑
            </el-button>
            <el-button plain size="small" type="primary" @click="openBatchImport('batchImportApply')">批量导入申请</el-button>
            <el-button plain size="small" type="primary" @click="openBatchImport('historyImport')">历史数据导入</el-button>
            <el-button plain size="small" type="primary" @click="openBatchImport('batchApplyCode')">批量申请编码</el-button>
            <el-button plain size="small" type="primary">批量发布</el-button>
            <el-button plain size="small" type="primary">查看流程历史</el-button>
            <el-button plain size="small" type="primary">删除</el-button>
            <el-button plain size="small" type="primary" @click="setHandler">发布</el-button>
            <el-button plain size="small" type="primary" @click="DataChange">数据更改</el-button>
            <el-button plain size="small" type="primary" @click="huishouHandler">回收</el-button>
            <el-button plain size="small" type="primary" @click="openD">导出
            </el-button>
            <el-button plain size="small" type="primary" @click="findHandler">查询
            </el-button>
            <el-button plain size="small" type="primary" @click="similarHandler">相似项查询</el-button>
            <el-button plain size="small" type="primary">刷新</el-button>
            <el-input placeholder="请输入关键字按回车查询" size="small"
              style="width: 180px; margin-left: 5px; margin-top: 10px"></el-input> -->

          </div>
          <el-row style="width: 100%;margin-bottom: 20px">
            <div>
              <el-button v-for="(item, index) in masterVrBtnList" v-if="!['PREVIEW', 'DELETEFILE', 'revisefile', 'DOWNLOADFILE', 'UPLOADFILE'].includes(item.uniqueFlag)" :key="index" plain size="small"
                         type="primary"
                         @click="handelBtnClick(item)">{{
                  item.name
                }}
              </el-button>
              <el-input v-model="WupinFindValue" placeholder="请输入关键字按回车查询"
                        size="small" style="width: 180px; margin-left: 5px; margin-top: 10px"
                        @keyup.enter.native="tableFindInp"></el-input>
            </div>
            <el-table v-if="tableData.length != 0" ref="dataTable" v-loading="isLoading" :data="tableData"
                      :height="tableHeight"
                      @select="handleSelection" @cell-click="handleCellClick" @row-click="handleRowClick"
                      @select-all="handleSelectionAll" @selection-change="handleSelectionChange"
                      @sort-change="sortChange">
              <el-table-column fixed type="selection" width="55"></el-table-column>
              <el-table-column fixed label="序号" type="index" width="55">
              </el-table-column>
              <el-table-column v-for="item in this.tableHeadFindData" :key="item.id" :formatter="item.formatter"
                               :label="item.label"
                               :prop="item.prop" :show-overflow-tooltip="true"
                               :sortable="item.sortable"
                               :width="item.label.length >= 4 ? '150' : item.label.length == 3 ? '120' : '90'"
                               align="center">
              </el-table-column>
            </el-table>
          </el-row>
          <!--          新增-->
          <FormTemplateDialog :codeClassifyOid="this.codeClassifyOid" :codeRuleOid="this.codeRuleOid"
                              :disabledProp="disabledProp" :templateOid="templateOid" :visible.sync="addvisible"
                              type="add"
                              @submit="AddSumbit">
          </FormTemplateDialog>
          <!--          修改-->
          <FormTemplateDialog :codeClassifyOid="this.codeClassifyOid" :codeRuleOid="this.codeRuleOid"
                              :disabledProp="disabledProp" :rowOid="rowOid" :templateOid="templateOid" :title="'修改编码信息'"
                              :visible.sync="editvisible"
                              type="edit" @submit="EditSumbit"></FormTemplateDialog>
          <!--          已发布数据修改-->
          <FormTemplateDialog :codeClassifyOid="this.codeClassifyOid" :codeRuleOid="this.codeRuleOid"
                              :disabledProp="disabledProp" :rowOid="rowOid" :templateOid="templateOid"
                              :title="'已发布数据更改'"
                              :type="edit"
                              :visible.sync="DataVisible"></FormTemplateDialog>
          <!--          发布-->
          <set-personnel :parameter="this.parameter" :title="title" :visible.sync="visibleFlow"></set-personnel>
          <!--          停用-->
          <set-personnel :parameter="this.parameter" :title="title" :visible.sync="visibleDeactivate"></set-personnel>
          <!--          启用-->
          <set-personnel :parameter="this.parameter" :title="title" :visible.sync="visibleEnable"></set-personnel>
          <!--          回收-->
          <set-personnel :parameter="this.parameter" :title="title" :visible.sync="visibleRecovery"></set-personnel>
          <!--          高级查询-->
          <advanced-query :options="this.options" :visible.sync="findvisible"
                          @echoContion="echoContion"></advanced-query>
          <!--          导出-->
          <MasterTransfer :codeClassifyOid="codeClassifyOid" :selectRow="selectRow"
                          :tableData="tableData" :tableHeadData="tableHeadFindData"
                          :visible.sync="dialogPush"></MasterTransfer>
          <!--          相似项-->
          <ResembleQueryDialog :codeClassifyOid="codeClassifyOid" :codeRuleOid="this.codeRuleOid" :rowOid="rowOid"
                               :templateOid="templateOid" :visible.sync="similarVisible"></ResembleQueryDialog>
          <div class="block" style="display: flex; justify-content: flex-end">
            <el-pagination :current-page="page.currentPage" :page-size="page.pageSizes" :page-sizes="page.pageSizes"
                           :total="page.total" layout="total, sizes, prev, pager, next, jumper"
                           @size-change="handleSizeChange"
                           @current-change="handleCurrentChange">
            </el-pagination>
          </div>
        </div>
        <BatchImport v-if="batchImportData.visible" v-bind="batchImportData" :visible.sync="batchImportData.visible">
        </BatchImport>
      </div>
      <div class="bottom">
        <el-collapse v-model="visibleNames" @change="handleCollapse">
          <el-collapse-item name="1" title="附件列表">
            <fileInHtml :options="fileOptions"></fileInHtml>
          </el-collapse-item>
        </el-collapse>
      </div>
    </div>
  </basic-container>
</template>
<script>
import {MasterTable, TableData, FindData, addSaveCode, editSaveCode} from "@/api/GetItem";
import {listCodeAttributeByClassId} from "@/api/integration/integration.js";
import integrationTransfer from "@/views/integration/integrationTransfer";
import SetPersonnel from "@/components/template/SetPersonnel";
import ResembleQueryDialog from "@/components/FormTemplate/ResembleQueryDialog.vue";
import BatchImport from '@/components/BatchImport'
import {validatenull} from "@/util/validate";
import fileInHtml from "@/components/file/inHtml.vue";

export default {
  components: {
    integrationTransfer,
    SetPersonnel,
    ResembleQueryDialog,
    BatchImport,
    fileInHtml
  },
  name: "Crud.vue",
  props: {
    page: {
      type: Object,
      default: () => {
        return {};
      },
    },
    codeClassifyOid: {
      type: String,
      default: "",
    },
    coderuleoid: {
      type: String,
      default: "",
    },
    tableDataArray: {
      type: Array,
    },
    total: {
      type: String,
      default: "",
    },
    templateOid: {
      type: String,
      default: "",
    },
    tableHeadDataFateher: {
      type: Array,
    },
    isLoading: {
      type: Boolean,
      default: false,
    },
    tableHeadFindData: {
      type: Array,
    },
    tableHeadBtnData: {
      type: Array,
    },
  },
  data() {
    return {
      searchResults:[],
      //首页右侧搜索
      WupinFindValue: "",
      //相似项查询
      similarVisible: false,
      //发布
      parameter: {
        ids: [],
        code: "",
        type: '',
        // this.visibleDeactivate ?'ENABLE':this.visibleEnable ? 'DISABLE' :this.visibleRecovery ? 'ROLLBACK' :'PUBLIC'
        template: "",
        vars: {
          codeClassifyOid: "",
          templateOid: ""
        }
      },
      visibleNames: [],
      //发布
      visibleFlow: false,
      //停用
      visibleDeactivate: false,
      //启用
      visibleEnable: false,
      //回收
      visibleRecovery: false,
      title: '',
      transferData: [],
      transferProps: {
        key: "oid",
        label: "name",
      },
      tableHeadFindDatas: [],
      addvisible: false,
      editvisible: false,
      findvisible: false,
      dialogPush: false,
      rowOid: "",
      disabledProp: ["id"],
      editingRow: null,
      editShow: "",
      editAttr: "",
      data: [],
      options: {},
      option: {
        column: [],
      },
      List: [],
      columnType: {
        text: "input",
        combox: "select",
        truefalse: "switch",
        number: "number",
        datetime: "datetime",
      },
      tableData: [],
      tableHeight: 'calc(100vh - 330px)',
      DataVisible: false,
      tableHeadData: [],
      items: {},
      seniorQueryColumns: [],
      selectRow: [],
      userName: "",
      batchImportData: {
        visible: false,
        type: '',
        codeClassifyOid: ''
      },
      // 主数据按钮
      masterVrBtnList: [],
      fileOptions: {
        ownbizOid: "0",
        ownbizBtm: "0",
        fileDocClassify: '!=processAuditSuggest',
        fileDocClassifyName: '',
        hasDownload: true,
        hasUpload: true,
        height: 100
      }
    };
  },
  computed: {},
  created() {
  },
  mounted() {
  },
  activated() {
    // this.doLayout();
  },
  watch: {
    tableHeadDataFateher: {
      handler(newval, oldval) {
        this.options = newval.tableDefineVO.seniorQueryColumns
      }
    },
    codeClassifyOid: {
      handler(newval, oldval) {
        this.codeClassifyOid = newval;
        this.parameter.vars.codeClassifyOid = newval
      },
      deep: true,
    },
    tableDataArray: {
      handler(newval, oldval) {
        this.tableData = newval;
      },
    },
    tableHeadFindData: {
      handler(newval, oldval) {
        newval.forEach((record, _index) => {
          if (record.field == 'id' && validatenull(record.templet)) {
            //企业编码的默认添加超链接,暂未实现
            record.formatter = '';
          } else {
            if (record.templet && typeof (record.templet) == 'string' && !validatenull(record.templet) && record.templet.indexOf("function(row,column)") > -1) {
              record.formatter = eval("(" + record.templet + ")");
              //function(row,column){return row[column.property]=='true' || row[column.property]=='1'?'是':'否'}
            } else if (record.fieldType == "truefalse") {
              record.formatter = function (row, column) {
                return row[column.property] == 'true' || row[column.property] == '1' ? '是' : '否'
              }
            }
          }
        })
        this.tableHeadFindDatas = newval;
      },
    },
    total: {
      handler(newval, oldval) {
        this.page.total = newval;
      },
    },
    templateOid: {
      handler(newval, oldval) {
        this.parameter.code = newval;
        this.fileOptions.ownbizOid = "0";
        this.parameter.vars.templateOid = newval
      },
      deep: true,
    },
    tableHeadBtnData: {
      handler(newval) {
        if (newval.length !== 0) {
          this.masterVrBtnList = newval
        }
      },
      deep: true
    }
  },
  methods: {
    //展开附件
    handleCollapse(activeNames) {
      if (activeNames.length > 0) {
        this.tableHeight = 'calc(100vh - 630px)';
        this.$refs.dataTable.doLayout()
      } else {
        this.tableHeight = 'calc(100vh - 330px)';
        this.$refs.dataTable.doLayout()
      }
    },
    openVis(visible) {
      console.log(visible)
      this[visible] = true
    },
    handelBtnClick(event) {
      const {uniqueFlag} = event
      this.$nextTick(() => {
        if (uniqueFlag === 'CODEADD') return this.addvisible = true
        if (uniqueFlag === 'CODEEDIT') return this.editHandler()
        if (uniqueFlag === 'CODEBATCHADD') return this.openBatchImport('batchImportApply')
        if (uniqueFlag === 'CODEIMPORTHISTORY') return this.openBatchImport('historyImport')
        if (uniqueFlag === 'batchApplyCode') return this.openBatchImport('batchApplyCode')
        // 批量申请编码
        //  if(uniqueFlag === 'CODEEDIT') return this.openBatchImport('batchApplyCode')
        if (uniqueFlag === 'CODESTARTPROCESS') return this.setHandler()
        if (uniqueFlag === 'CODEUPREVISION') return this.DataChange()
        if (uniqueFlag === 'CODEEXPORT') return this.openD()
        if (uniqueFlag === 'CODEQUERY') return this.findHandler()
        //停用
        if (uniqueFlag === 'CODEDISABLE') return this.Deactivate()
        //启用
        if (uniqueFlag === 'CODEENABLE') return this.Enable()
        //回收
        if (uniqueFlag === 'CODERECYCLE') return this.Recovery()
        //  相似项查询
        //  if(uniqueFlag === 'CODEEDIT') return this.similarHandler()
      });
    },
    openD() {
      this.getListCodeByClassId();
    },
    async getListCodeByClassId() {
      this.dialogPush = true;
      this.transferData = [];
      const response = await listCodeAttributeByClassId({
        codeClassifyId: this.codeClassifyOid,
      });
      if (response.status === 200) {
        const data = response.data.data;
        this.transferData = data;
      }
    },
    handelTransferSave(val) {
      console.log('发布', val)
    },
    rend() {
      this.tableData = this.tableHeadData;
    },
    // 发布
    setHandler() {
      // let EditFlag1=false
      // let EditFlag2=false
      // if(EditFlag1){
      //   this.$message.warning('只有状态是【编辑中】的数据才可以发起流程')
      // }else if(EditFlag2){
      //   this.$message.warning('您选择的数据全部为【编辑中】才可以发起流程')
      // }
      this.selectRow.forEach(item => {
        if (this.selectRow.length === 1 && item.lcstatus !== "Editing") {
          this.$message.warning('只有状态是【编辑中】的数据才可以发起流程')
        } else if (item.lcstatus !== 'Editing') {
          this.$message.warning('您选择的数据全部为【编辑中】才可以发起流程')
        } else {
          this.userName = localStorage.getItem("username");
          this.parameter.template = this.userName + "-发布" + "[物品]";
          this.parameter.type = 'PUBLIC'
          this.title = '流程审批'
          this.visibleFlow = true;
        }
      })
      // if (this.selectRow.length <= 0) {
      //   this.$message.warning("请选择一条数据");
      // } else {
      //   this.userName = localStorage.getItem("username");
      //   this.parameter.template = this.userName + "-发布" + "[物品]";
      //   this.parameter.type='PUBLIC'
      //   this.title='流程审批'
      //   this.visibleFlow = true;
      // }
    },
    //停用
    Deactivate() {
      if (this.selectRow.length <= 0) {
        this.$message.warning("请选择一条数据");
      } else {
        this.userName = localStorage.getItem("username");
        this.parameter.template = this.userName + "-发布" + "[物品]";
        this.parameter.type = 'DISABLE'
        this.title = '停用（冻结）编码数据'
        this.visibleDeactivate = true;
      }
    },
    //启用
    Enable() {
      if (this.selectRow.length <= 0) {
        this.$message.warning("请选择一条数据");
      } else {
        this.userName = localStorage.getItem("username");
        this.parameter.template = this.userName + "-发布" + "[物品]";
        this.parameter.type = 'ENABLE'
        this.title = '启用（解冻）编码数据'
        this.visibleEnable = true;
      }
    },
    //回收
    Recovery() {
      if (this.selectRow.length <= 0) {
        this.$message.warning("请选择一条数据");
      } else {
        this.userName = localStorage.getItem("username");
        this.parameter.template = this.userName + "-发布" + "[物品]";
        this.parameter.type = 'ROLLBACK'
        this.title = '回收编码数据'
        this.visibleRecovery = true;
      }
    },
    handleSizeChange(val) {
      this.isLoading = true;
      setTimeout(() => {
        this.page.pageSize = val;
        this.$emit("pageSize", val);
        this.CrudRend();
      }, 3000);
    },
    handleCurrentChange(val) {
      this.isLoading = true;
      setTimeout(() => {
        this.page.currentPage = val;
        this.$emit("currentPage", val);
        this.CrudRend();
      }, 3000);
    },
    // 监听单元格点击事件并存储正在编辑的行
    handleCellClick(row, column) {
      this.editingRow = row;
      this.editShow = column.property;
      this.rowOid = row.oid;
    },
    handleRowClick(row, column) {
      this.fileOptions.ownbizOid = row.oid;
      this.fileOptions.ownbizBtm = row.btmname;
      this.$refs.dataTable.toggleRowSelection(row);
    },
    //删除
    enumDeleteRow(row) {
      this.tableData.splice(row, 1);
    },
    // 将正在编辑的行的状态变为 null ，即退出编辑状态
    saveRow() {
      this.editingRow = null;
    },
    doLayout() {
      this.$nextTick(() => {
        console.log(this.$refs)
        this.$refs.crud.doLayout();
      });
    },
    //表格头渲染
    CrudHeaderRend() {
      if (this.codeClassifyOid != "") {
        MasterTable({
          codeClassifyOid: this.codeClassifyOid
        }).then((res) => {
          this.options = res.data.tableDefineVO.seniorQueryColumns;
          this.List = res.data.tableDefineVO.cols[0];
          this.List.forEach((item) => {
            let columnItem = {
              label: item.title,
              prop: item.field,
              type: this.columnType[item.type],
              sortable: item.sort,
              width: item.minWidth,
            };
            this.option.column.push(columnItem);
            this.option.column = this.tableHeadData;
            this.templateOid = res.data.tableDefineVO.oid;
            this.$emit("templateOid", this.templateOid);
          });
        });
      }
    },
    //表格数据
    CrudRend() {
      TableData({
        templateOid: this.templateOid,
        codeClassifyOid: this.codeClassifyOid,
        page: this.page.currentPage,
        limit: this.page.pageSize,
      }).then((res) => {
        this.page.total = res.data.total;
        this.data = res.data.data;
        this.tableData = res.data.data;
      });
    },
    // 排序
    sortChange(val) {
      this.isLoading = true;
      let order = "";
      if (val.order == "ascending") {
        order = "asc";
      } else {
        order = "desc";
      }
      TableData({
        templateOid: this.templateOid,
        codeClassifyOid: this.codeClassifyOid,
        order: order,
        sort: val.prop,
        page: this.page.currentPage,
        limit: this.page.pageSize,
      }).then((res) => {
        setTimeout(() => {
          this.data = res.data.data;
          this.isLoading = false;
        }, 100);
      });
    },
    //分页刷新
    async onLoad(val) {
      await TableData({
        templateOid: this.templateOid,
        codeClassifyOid: this.codeClassifyOid,
        page: this.page.currentPage,
        limit: this.page.pageSize,
      }).then((res) => {
        this.tableData = res.data.data;
      });
    },
    //多选
    handleSelectionChange(list) {
      this.selectRow = list;
      this.parameter.ids = [];
      list.forEach((item) => {
        this.parameter.ids.push(item.oid);
      });
    },
    //选择
    handleSelection(list, row) {
      this.fileOptions.ownbizOid = row.oid;
      this.fileOptions.ownbizBtm = row.btmname;

    },
    //选择全部
    handleSelectionAll() {
      this.fileOptions.ownbizOid = '0';
      this.fileOptions.ownbizBtm = '0';

    },
    //编辑
    editHandler() {
      if (this.selectRow.length <= 0) {
        this.$message.warning("请选择一条数据");
      } else if (this.selectRow.length > 1) {
        this.$message.warning("只能选择一条数据");
      } else if (this.selectRow[0].lcstatus != "Editing") {
        this.$message.warning("编码状态不是“编辑中”,不可编辑");
      } else {
        this.editvisible = true;
        this.rowOid = this.selectRow[0]['oid']
      }
    },
    //高级查询按钮
    findHandler() {
      this.findvisible = true;
    },
    // 高级查询
    echoContion(val) {
      FindData({
        templateOid: this.templateOid,
        codeClassifyOid: this.codeClassifyOid,
        ...val,
      }).then((res) => {
        console.log(res);
        this.tableData = res.data.data;
        this.page.total = res.data.total
      });
    },
    //相似项查询
    similarHandler() {
      if (this.selectRow.length <= 0) {
        this.$message.warning("请选择一条数据");
      } else if (this.selectRow.length > 1) {
        this.$message.warning("只能选择一条数据");
      } else {
        this.similarVisible = true;
      }
    },
    //数据更改
    DataChange() {
      if (this.selectRow.length <= 0) {
        this.$message.warning("请选择一条数据");
      } else if (this.selectRow.length > 1) {
        this.$message.warning("只能选择一条数据");
      } else if (this.selectRow[0].lcstatus != "Released") {
        this.$message.warning("只有状态为已发布的数据才能进行数据更改");
      } else {
        this.DataVisible = true;
      }
    },
    //增加保存
    AddSumbit(val) {
      this.addvisible = false;
      console.log(val)
      addSaveCode(val).then(res => {
        console.log(res)
        this.$nextTick(() => {
          this.onLoad()
        })
      })
    },
    EditSumbit(val) {
      this.editvisible = false;
      console.log(val)
      editSaveCode(val).then(res => {
        console.log(res)
        this.$nextTick(() => {
          this.onLoad()
        })
      })
    },
    openBatchImport(type) {
      this.batchImportData.visible = true
      this.batchImportData.type = type
      this.batchImportData.codeClassifyOid = this.codeClassifyOid
    },
    //输入回车搜索
    tableFindInp(event) {
      console.log('回车键被按下');
      console.log(this.WupinFindValue)
      console.log(this.tableData)
      // 在这里执行你的操作
      // let referList=[]
      // this.tableData.filter(item => {
        // console.log(item.name.includes(this.WupinFindValue))
        // console.log(item.name.indexOf(this.WupinFindValue)>=0)
      // })
      // const regex = new RegExp(this.WupinFindValue, 'i');
      // this.tableData.filter(item => {
      //   console.log(regex.test(item.name))
      //   // return regex.test(item.name);
      // });
      if (this.WupinFindValue.trim() === '') {
        this.searchResults = []; // 输入值为空，清空搜索结果
        return;
      }

        this.tableData = this.tableData.filter(item => {
        if (typeof item.name === 'string') {
          return item.name.includes(this.WupinFindValue);
        }else {
          return false; // item.name不是字符串类型，返回false
        }

      });
      console.log(this.searchResults);

    }

  }
};
</script>

<style lang="scss" scoped>
.testbox {
  .el-table--scrollable-x .el-table__body-wrapper {
    overflow: auto !important;
  }

  .el-table__fixed-right-patch {
    background-color: #f5f7fa !important;
  }
}

/deep/ .el-button {
  margin: 0 10px 10px 0;
}

.main {
  display: flex;
  flex-direction: column;
  height: calc(100vh - 150px);
  min-height: 400px;
}

.top {
  overflow-y: scroll;
  min-height: 55%;
}

.bottom {
  margin-top: 20px;
  overflow-y: scroll;
}

.el-collapse-item__content {
  padding-bottom: 0;
}
</style>
